
set serveroutput on
set echo on

CREATE TABLE emp_copy
AS
   SELECT *
   FROM   emp
   WHERE  ROWNUM < 1;


DECLARE

   CURSOR c_emps IS
      SELECT empno
      ,      ename
      ,      job
      ,      hiredate
      FROM   emp;

   TYPE emp_aat IS TABLE OF c_emps%ROWTYPE
      INDEX BY PLS_INTEGER;
   aa_emps emp_aat;

BEGIN

   /* Bulk fetch sample data... */
   OPEN c_emps;
   FETCH c_emps BULK COLLECT INTO aa_emps;
   CLOSE c_emps;

   /* FORALL INSERT..VALUES for the first time with record-arrays... */
   FORALL i IN INDICES OF aa_emps
      INSERT INTO emp_copy ( empno
                           , ename
                           , job
                           , hiredate
                           )
      VALUES ( aa_emps(i).empno
             , aa_emps(i).ename
             , aa_emps(i).job
             , aa_emps(i).hiredate
             );

   DBMS_OUTPUT.PUT_LINE(
      TO_CHAR(SQL%ROWCOUNT) || ' rows inserted.'
      );

END;
/

