
set serveroutput on
set echo on

exec runstats_pkg.rs_start;

DECLARE
  
   CURSOR c_emps IS
      SELECT emp_large_ot(empno, ename, job, mgr,
                          hiredate, sal, comm, deptno)
      FROM   emp_large;

   nt_emps emp_large_ntt;
   v_cnt   PLS_INTEGER := 0;

BEGIN

   OPEN c_emps;
   LOOP

      FETCH c_emps BULK COLLECT INTO nt_emps LIMIT 500;

      FORALL i IN INDICES OF nt_emps
         UPDATE emp_large
         SET    ename    = TREAT(nt_emps(i) AS emp_large_ot).ename
         ,      job      = TREAT(nt_emps(i) AS emp_large_ot).job
         ,      mgr      = TREAT(nt_emps(i) AS emp_large_ot).mgr
         ,      hiredate = TREAT(nt_emps(i) AS emp_large_ot).hiredate
         ,      sal      = TREAT(nt_emps(i) AS emp_large_ot).sal
         ,      comm     = TREAT(nt_emps(i) AS emp_large_ot).comm
         ,      deptno   = TREAT(nt_emps(i) AS emp_large_ot).deptno
         WHERE  empno    = TREAT(nt_emps(i) AS emp_large_ot).empno;

      v_cnt := v_cnt + SQL%ROWCOUNT;

      EXIT WHEN c_emps%NOTFOUND;

   END LOOP;
   CLOSE c_emps;

   DBMS_OUTPUT.PUT_LINE(TO_CHAR(v_cnt) || ' records updated.');

   COMMIT;

END;
/

exec runstats_pkg.rs_middle;
   
DECLARE
  
   CURSOR c_emps IS
      SELECT *
      FROM   emp_large;

   TYPE emp_large_ntt IS TABLE OF c_emps%ROWTYPE;

   nt_emps emp_large_ntt;
   v_cnt   PLS_INTEGER := 0;

BEGIN

   OPEN c_emps;
   LOOP

      FETCH c_emps BULK COLLECT INTO nt_emps LIMIT 500;

      FORALL i IN INDICES OF nt_emps
         UPDATE emp_large
         SET    ename    = nt_emps(i).ename
         ,      job      = nt_emps(i).job
         ,      mgr      = nt_emps(i).mgr
         ,      hiredate = nt_emps(i).hiredate
         ,      sal      = nt_emps(i).sal
         ,      comm     = nt_emps(i).comm
         ,      deptno   = nt_emps(i).deptno
         WHERE  empno    = nt_emps(i).empno;

      v_cnt := v_cnt + SQL%ROWCOUNT;

      EXIT WHEN c_emps%NOTFOUND;

   END LOOP;
   CLOSE c_emps;

   DBMS_OUTPUT.PUT_LINE(TO_CHAR(v_cnt) || ' records updated.');

   COMMIT;

END;
/

exec runstats_pkg.rs_stop(500);

   
